﻿using System;
using System.Data;
    
using System.Web.Configuration;
using System.Data.SqlClient;
using System.Text;
    
public partial class DataSetRelationShips : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        // Извлекаем строку соединения с именем Northwind из файла web.config
        string connectionString = WebConfigurationManager.
            ConnectionStrings["Northwind"].ConnectionString;
    
        // Создаем объект соединения
        SqlConnection con = new SqlConnection(connectionString);
    
        // Формируем строку SQL-запроса для заданных полей
        string sqlProducts = "SELECT ProductName, Discontinued FROM Products";
    
        // Создаем и настраиваем объект DataAdapter
        SqlDataAdapter adapter = new SqlDataAdapter(sqlProducts, con);
    
        // Создаем пустой объект DataSet набора данных
        DataSet dataset = new DataSet();
    
        // Выполняем запрос к БД с автоматическим 
        // открытием и закрытием соединения
        try
        {
            // Добавить в DataSet данные с именованной
            // меткой ProdTable из таблицы Products
            adapter.Fill(dataset, "ProdTable");
        }
        catch
        {
            throw new ApplicationException("Ошибка данныx.");
        }
    
        // Получить по дополнительному условию
        // массив продуктов, имеющих скидки
        DataRow[] matchRows = dataset.Tables["ProdTable"].
            Select("Discontinued <> 0"); // Дополнительное условие
    
        // Выбрать имена продуктов со скидками
        StringBuilder htmlStr = new StringBuilder("");
        htmlStr.Append("<ol>"); // Открыли нумерованный список HTML
        foreach (DataRow row in matchRows)
        {
            htmlStr.Append("<li>"); // Элемент маркированного списка HTML
            htmlStr.Append(row["ProductName"].ToString());  // Имя поля
            htmlStr.Append("</li>");
        }
        htmlStr.Append("</ol>"); // Закрыли нумерованный список HTML
    
        // Отображаем полученные данные пользователю
        lblInfo.Text = "<h2>Список продуктов,<br />имеющих скидки</h2>";
        lblInfo.Text += htmlStr.ToString();
    }
}
