﻿using System;
using System.Data;
    
using System.Web.Configuration;
using System.Data.SqlClient;
using System.Text;
    
public partial class DataViewRelation : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        // Извлекаем строку соединения с именем Northwind из файла web.config
        string connectionString = WebConfigurationManager.
            ConnectionStrings["Northwind"].ConnectionString;
    
        // Создаем объект соединения
        SqlConnection con = new SqlConnection(connectionString);
    
        // Формируем строки SQL-запросов
        string sqlCategories = "SELECT CategoryID, CategoryName FROM Categories";
        string sqlProducts = "SELECT ProductName, CategoryID, UnitPrice FROM Products";
    
        // Создаем объект DataAdapter
        SqlDataAdapter adapter = new SqlDataAdapter(sqlCategories, con);
    
        // Создаем пустой объект DataSet набора данных
        DataSet dataset = new DataSet();
    
        // Выполняем два запроса к БД с открытием 
        // и закрытием соединения вручную.
        // Возможные исключения не обрабатываем, а просто подавляем
        try
        {
            con.Open();
            // Наполнить DataSet данными из таблицы Categories
            // с именованной меткой CatTable
            adapter.Fill(dataset, "CatTable");
            // Сменить команду и добавить в DataSet данные
            // с именованной меткой ProdTable из таблицы Products
            adapter.SelectCommand.CommandText = sqlProducts;
            adapter.Fill(dataset, "ProdTable");
        }
        finally
        {
            con.Close();
        }
    
        // Определение отношения между  извлеченными в DataSet
        // именованными данными CatTable и ProdTable
        DataRelation relation = new DataRelation(
            "CatProd",                                          // Имя отношения
            dataset.Tables["CatTable"].Columns["CategoryID"],   // Родительская таблица
            dataset.Tables["ProdTable"].Columns["CategoryID"]   // Дочерняя таблица
                                                    );
        // Добавление отношения в коллекцию отношений DataSet
        dataset.Relations.Add(relation);
    
        // Создаем объект DataView, в который загружаем данные CatTable
        DataView view1 = new DataView(dataset.Tables["CatTable"]);
    
        // Устанавливаем фильтр для отображения только категорий продуктов,
        // цена которых в связанной таблице продуктов удовлетворяет условию
        // "Самый дорогой продукт дороже 50"
        view1.RowFilter = "MAX(Child(CatProd).UnitPrice) > 50";
    
        // Показываем отфильтрованные данные пользователю
        GridView1.DataSource = view1;
        GridView1.DataBind();
    }
}
