﻿using System;
using System.Data;
    
using System.Web.Configuration;
using System.Data.SqlClient;
using System.Text;
    
public partial class ExpressionColumns : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        // Извлекаем строку соединения с именем Northwind из файла web.config
        string connectionString = WebConfigurationManager.
            ConnectionStrings["Northwind"].ConnectionString;
    
        // Формируем строку SQL для выборки всех данных таблицы Employees
        string commandString = "SELECT * FROM Employees";
    
        // Создаем и настраиваем экземпляр класса SqlDataAdapter
        SqlDataAdapter adapter = 
            new SqlDataAdapter(commandString, connectionString);
    
        // Создаем объект DataSet результирующего набора данных
        DataSet dataset = new DataSet();
    
        // Безопасно заполняем данными объект DataTable с произвольным 
        // именем, например "EmployeesResult", созданного объекта DataSet
        try
        {
            adapter.Fill(dataset, "EmployeesResult");
        }
        catch
        {
            throw new ApplicationException("Ошибка данныx.");
        }
    
        // Создаем именованный столбец и добавляем к таблице в DataSet
        string strExpr = 
            "'Сотрудник ' + TitleOfCourtesy + ' ' + LastName + ', ' + FirstName";
        DataColumn column = new DataColumn("FullName", typeof(string), strExpr);
        dataset.Tables["EmployeesResult"].Columns.Add(column);
    
        // Перебираем все объекты DataRow с полученным записами
        StringBuilder htmlStr = new StringBuilder("");
        foreach (DataRow dr in dataset.Tables["EmployeesResult"].Rows)
        {
            htmlStr.Append("<li>");
            // Существующий столбец
            htmlStr.Append(dr["EmployeeID"].ToString() + ") ");
            htmlStr.Append("<b>");
            // Новый столбец
            htmlStr.Append(dr["FullName"].ToString());  
            htmlStr.Append("</b>");
            htmlStr.Append("</li>");
        }
    
        // Отображаем полученные данные
        lblInfo.Text = "<h2>Список сотрудников</h2>";
        lblInfo.Text += htmlStr.ToString();
    }
}
