﻿using System;
        
using System.Text;
using System.Collections.Generic;
        
public partial class TestComponent : System.Web.UI.Page
{
    // Создать компонент базы данных
    private EmployeeDB db = new EmployeeDB();
    
    protected void Page_Load(object sender, EventArgs e)
    {
        lblInfo.Text = "<h2>Исходная таблица</h2>";
        WriteEmployeesList();
        
        int empID = db.InsertEmployee(
            new EmployeeDetails(0, "Алексей", "Зиборов", "Ст."));
        lblInfo.Text += "<h2>Вставлена 1 запись.</h2>";
        WriteEmployeesList();
    
        db.DeleteEmployee(empID);
        lblInfo.Text += "<h2>Удалена 1 запись.</h2>";
        WriteEmployeesList();
    }
    
    private void WriteEmployeesList()
    {
        StringBuilder htmlStr = new StringBuilder("");
    
        List<EmployeeDetails> employees = db.GetAllEmployees();
        foreach (EmployeeDetails emp in employees)
        {
            htmlStr.Append("<li>");
            htmlStr.Append(emp.EmployeeID);
            htmlStr.Append(" ");
            htmlStr.Append(emp.TitleOfCourtesy);
            htmlStr.Append(" <b>");
            htmlStr.Append(emp.FirstName);
            htmlStr.Append("</b>, ");
            htmlStr.Append(emp.LastName);
            htmlStr.Append("</li>");
        }
          
        int numEmployees = db.CountEmployees();
        htmlStr.Append("<hr />Число записей: <b>");
        htmlStr.Append(numEmployees.ToString());
        htmlStr.Append("</b><br /><br />");
        lblInfo.Text += htmlStr.ToString();
    }
}
